
'$DYNAMIC
DEFINT A-Z

DECLARE SUB ScrollMessage ()
DECLARE SUB CalibrateJoystick ()
DECLARE SUB MessageBox ()
DECLARE SUB SendMessage (objectnumber%, MessageData%)
DECLARE SUB ActivateRadius (objectnumber%, MessageNum%)
DECLARE SUB ExecuteScript (objectnumber%)
DECLARE SUB TransBox (TopLeftX%, TopLeftY%, BottomRightX%, BottomRightY%, TransType%)
DECLARE SUB LoadMap ()
DECLARE SUB Display (array%(), MapX%, MapY%, MaxX%, MaxY%, displayer%)
DECLARE SUB UpdateObjects (layer%)
DECLARE SUB MoveObject (objectnumber%, pixelmovesX%, pixelmovesY%)
DECLARE FUNCTION MoveObjectHelper% (O%, OX%, OY%, OXO%, OYO%, X%, Y%, XO%, YO%, ThisMapLevel() AS INTEGER)
DECLARE SUB CenterCamera ()
DECLARE SUB FontPrint (textstring$, X%, Y%)
DECLARE SUB BloadX (file$, SGment%, Offset%, NumBytes!, FilePointer!)
DECLARE SUB Keys ()
DECLARE SUB LoadTiles ()
DECLARE SUB Intro ()
DECLARE SUB ScreenX (modenumber%)
DECLARE SUB LoadPal (filename$)
DECLARE SUB Copy13h ()
DECLARE SUB put13h (BYVAL OBJSegm%, BYVAL OBJOffs%, BYVAL X%, BYVAL Y%, BYVAL Col%)
DECLARE SUB SetSegments13h (BYVAL SSegm%, BYVAL DSegm%)
DECLARE SUB initkbd ALIAS "installisr" (BYVAL arrayseg%, BYVAL arrayofs%)
DECLARE SUB deinitkbd ALIAS "removeisr" ()
DECLARE SUB BsaveX (file$, SGment, Offset%, NumBytes!, FilePointer!)
DECLARE SUB BloadX (file$, SGment, Offset%, NumBytes!, FilePointer!)
TYPE RegTypeX
 ax AS INTEGER
 bx AS INTEGER
 cx AS INTEGER
 dx AS INTEGER
 BP AS INTEGER
 si AS INTEGER
 di AS INTEGER
 flags AS INTEGER
 ds AS INTEGER
 es AS INTEGER
END TYPE
DECLARE SUB INTERRUPTX (intnum AS INTEGER, inreg AS RegTypeX, outreg AS RegTypeX)

DIM SHARED regs AS RegTypeX

TYPE ObjectScript
 Script AS STRING * 1000
 bytestowait AS INTEGER
 backtobyte AS INTEGER
 currentbyte AS INTEGER
 scriptisrunning AS INTEGER
END TYPE


TYPE DevicesProfile
 LeftArrow AS INTEGER
 RightArrow AS INTEGER
 UpArrow AS INTEGER
 DownArrow AS INTEGER
 Use AS INTEGER
 Status AS INTEGER
 Console AS INTEGER
 FastQuit AS INTEGER
 AskQuit AS INTEGER
 ScrollDown AS INTEGER
 Scrollup AS INTEGER
 CloseMessage AS INTEGER
 Running AS INTEGER
JoyX AS INTEGER
JoyY AS INTEGER
JoyStickButton1 AS INTEGER
JoyStickButton2 AS INTEGER
JoyStickButton3 AS INTEGER
JoyStickButton4 AS INTEGER
JoyStickLeft AS INTEGER
JoyStickRight AS INTEGER
JoyStickUp AS INTEGER
JoyStickDown AS INTEGER
END TYPE

TYPE TileTableData
 AnimationFrames AS INTEGER
 AnimationDelayFrames AS INTEGER
 Segment AS INTEGER
 Offset AS INTEGER
END TYPE

TYPE scrollymessagey
Text AS STRING * 1024
Positionx AS INTEGER
EndX AS INTEGER
END TYPE

TYPE ObjectData
 CharSetTile AS INTEGER
 MoveToX AS INTEGER
 MoveToY AS INTEGER
 ismoving AS INTEGER
 CurrentLayer AS INTEGER
 MapLocationX AS INTEGER
 MapLocationY AS INTEGER
 PixelLocationX AS INTEGER
 PixelLocationY AS INTEGER
 XAxisDirection AS INTEGER
 YAxisDirection AS INTEGER
 ActivatesScript AS INTEGER
 AnimationFrames AS INTEGER
 AnimationDelay AS INTEGER
 ObjectType AS INTEGER
 Steps AS LONG
 TileNumber AS INTEGER
 Stepping AS INTEGER
END TYPE

TYPE PlayerData
 PlayerName AS STRING * 16
 HitPoints AS INTEGER
 HitPointsMax AS INTEGER
 Strength AS INTEGER
 Endurance AS INTEGER
 Health AS INTEGER
END TYPE

CONST TRUE = -1
CONST FALSE = 0
CONST TransColor = 242

DIM SHARED MoveX
DIM SHARED MoveY
DIM SHARED ReasonToQuit
DIM SHARED CameraX, CameraY, CenteredCameraX, CenteredCameraY
DIM SHARED tiles(32759)
DIM SHARED TileData(503) AS TileTableData
DIM SHARED VSYNC
DIM SHARED MapLevel1(89, 89, 1)
DIM SHARED MapLevel2(89, 89, 1)
DIM SHARED MapLevel3(89, 89, 1)
DIM SHARED DevicesBuffer(300)
DIM SHARED Devices AS DevicesProfile
DIM SHARED bottombar(1281)
DIM SHARED FRAMES&
DIM SHARED buffer(31999)
DIM SHARED TextMessage(150) AS STRING * 38
DIM SHARED MessageBoxEnabled, MessageBoxLines, MessageBoxPositionY
DIM SHARED font(4351)
DIM SHARED CharSet(3095, 4)
DIM SHARED InfoLine AS scrollymessagey
DIM SHARED StartTime!
DIM SHARED flagnpc(63) AS INTEGER
DIM SHARED foundnpcs AS INTEGER
DIM SHARED objects(63) AS ObjectData
DIM SHARED transpal(255)
DIM SHARED scripts(63) AS ObjectScript
DIM SHARED buttontable(1 TO 4)
DIM SHARED DirectionData(-1 TO 1, -1 TO 1)

DIM SHARED JoyStickToggle

RANDOMIZE TIMER
SetSegments13h VARSEG(buffer(0)), &HA000

VSYNC = 1
IF UCASE$(COMMAND$) = "TURBO" THEN VSYNC = 0
CalibrateJoystick
ScreenX 19

Intro

OPEN "msg\scroll.msg" FOR BINARY AS #1
GET #1, , InfoLine.Text
InfoLine.EndX = INSTR(InfoLine.Text, CHR$(0)) - 41
CLOSE #1
InfoLine.Positionx = 0
LoadPal "qb.pal"
LoadTiles
LoadMap

FOR i = 0 TO 89
 FOR J = 0 TO 89
  MapLevel1(i, J, 1) = -1
  MapLevel2(i, J, 1) = -1
  MapLevel3(i, J, 1) = -1
 NEXT J
NEXT i

FOR i = 0 TO 63
 objects(i).ObjectType = -1
 objects(i).CurrentLayer = -1
NEXT i


'
' Player Data
'

objects(0).CharSetTile = 2
objects(0).ObjectType = 1
objects(0).CurrentLayer = 0
objects(0).PixelLocationX = 48
objects(0).PixelLocationY = 48
MapLevel1(3, 3, 1) = 0

FOR LoadScripts = 1 TO 4
OPEN "scrp\scrp.00" + LTRIM$(RTRIM$(STR$(LoadScripts))) FOR BINARY AS #1
GET #1, , objects(LoadScripts)
GET #1, , scripts(LoadScripts)
CLOSE #1
SELECT CASE objects(LoadScripts).CurrentLayer
CASE 0
MapLevel1(objects(LoadScripts).PixelLocationX \ 16, objects(LoadScripts).PixelLocationY \ 16, 1) = LoadScripts
CASE 1
MapLevel2(objects(LoadScripts).PixelLocationX \ 16, objects(LoadScripts).PixelLocationY \ 16, 1) = LoadScripts
CASE 2
MapLevel3(objects(LoadScripts).PixelLocationX \ 16, objects(LoadScripts).PixelLocationY \ 16, 1) = LoadScripts
END SELECT
NEXT

'Object 5

objects(5).CharSetTile = 1
objects(5).ObjectType = 2
objects(5).CurrentLayer = 1
objects(5).PixelLocationX = 240
objects(5).PixelLocationY = 96
scripts(5).backtobyte = 1
scripts(5).currentbyte = 1
scripts(5).scriptisrunning = 1
scriptpart$ = CHR$(2) + CHR$(17) + CHR$(7) + CHR$(3) + CHR$(255) + CHR$(2) + CHR$(15) + CHR$(5) + CHR$(3) + CHR$(255) + CHR$(255)
scriptpart$ = scriptpart$ + STRING$(127 - LEN(scriptpart$), CHR$(255))
scriptpart$ = scriptpart$ + CHR$(5) + CHR$(0) + CHR$(4) + CHR$(255)
scripts(5).Script = scriptpart$
MapLevel2(objects(5).PixelLocationX \ 16, objects(5).PixelLocationY \ 16, 1) = 5

'Player 2 or Object 6
objects(6).CharSetTile = 0
objects(6).ObjectType = 2
objects(6).CurrentLayer = 0
objects(6).PixelLocationX = 32
objects(6).PixelLocationY = 48
MapLevel1(2, 3, 1) = 6

'Object 7
objects(7).CharSetTile = -1
objects(7).TileNumber = 5
objects(7).ObjectType = 1
objects(7).CurrentLayer = 0
objects(7).PixelLocationX = 512
objects(7).PixelLocationY = 96
scripts(7).backtobyte = 1
scripts(7).currentbyte = 1
scripts(7).scriptisrunning = 1
scriptpart$ = CHR$(255)
scriptpart$ = scriptpart$ + STRING$(127 - LEN(scriptpart$), CHR$(255))
scriptpart$ = scriptpart$ + CHR$(7) + CHR$(0) + CHR$(1) + CHR$(255)
scripts(7).Script = scriptpart$
MapLevel1(objects(7).PixelLocationX \ 16, objects(7).PixelLocationY \ 16, 1) = 7



FOR i = 0 TO 251
 TileData(i).Segment = VARSEG(tiles(130 * i))
 TileData(i).Offset = VARPTR(tiles(130 * i))
 TileData(i + 252).Segment = VARSEG(tiles(130 * i))
 TileData(i + 252).Offset = VARPTR(tiles(130 * i))
 TileData(i + 252).AnimationFrames = 1
 TileData(i + 252).AnimationDelayFrames = 4
 TileData(i).AnimationFrames = 1
 TileData(i).AnimationDelayFrames = 4
NEXT i
TileData(13).AnimationFrames = 3
TileData(13).AnimationDelayFrames = 9
TileData(265).AnimationFrames = 3
TileData(265).AnimationDelayFrames = 9

OPEN "devices\Devices.cfg" FOR BINARY AS #1
GET #1, , Devices
CLOSE #1



DirectionData(-1, -1) = 2322
DirectionData(-1, 0) = 1548
DirectionData(-1, 1) = 0

DirectionData(0, -1) = 2322
DirectionData(0, 0) = 0
DirectionData(0, 1) = 0

DirectionData(1, -1) = 2322
DirectionData(1, 0) = 774
DirectionData(1, 1) = 774


initkbd VARSEG(DevicesBuffer(0)), VARPTR(DevicesBuffer(0))
StartTime! = TIMER
DO
 FRAMES& = FRAMES& + 1
blar = INP(&H201)

IF JoyStickToggle = 1 THEN
DevicesBuffer(Devices.JoyX) = STICK(0)
DevicesBuffer(Devices.JoyY) = STICK(1)
DevicesBuffer(Devices.JoyStickButton1) = blar \ 128
blar = blar - (DevicesBuffer(Devices.JoyStickButton1) * 128)
DevicesBuffer(Devices.JoyStickButton2) = blar \ 64
blar = blar - (DevicesBuffer(Devices.JoyStickButton2) * 64)
DevicesBuffer(Devices.JoyStickButton3) = blar \ 32
blar = blar - (DevicesBuffer(Devices.JoyStickButton3) * 32)
DevicesBuffer(Devices.JoyStickButton4) = blar \ 16
blar = blar - (DevicesBuffer(Devices.JoyStickButton4) * 16)
END IF

 UpdateObjects 0
 UpdateObjects 1
 UpdateObjects 2
 CameraX = objects(0).PixelLocationX + 8
 CameraY = objects(0).PixelLocationY + 8
 CenterCamera
 Display MapLevel1(), CenteredCameraX, CenteredCameraY, 19, 11, 0
 Display MapLevel2(), CenteredCameraX, CenteredCameraY, 19, 11, 1
 Display MapLevel3(), CenteredCameraX, CenteredCameraY, 19, 11, 2
 put13h VARSEG(bottombar(0)), VARPTR(bottombar(0)), 0, 192, -1
 IF MessageBoxEnabled THEN MessageBox
 ScrollMessage
 IF VSYNC = 1 THEN WAIT &H3DA, 8
 Copy13h
 ReasonToQuit = DevicesBuffer(Devices.FastQuit)
LOOP UNTIL ReasonToQuit
StopTime! = TIMER

deinitkbd

ScreenX 3
IF StartTime! > StopTime! THEN StopTime! = StopTime! + 86400
IF StartTime! <> StopTime! THEN PRINT USING "###.## fps"; FRAMES& / (StopTime! - StartTime!)
PRINT "RPGNext! v.9"
PRINT "by QbProgger"
PRINT "Assembly PUT/MEMCOPY routine by XlatB"
PRINT "Assembly keyboard ISR by LogicLord"
PRINT "some assistance by LogicLord with collision detection"
SYSTEM

REM $STATIC
SUB ActivateRadius (objectnumber, MessageNum)
MapPositionX = (objects(objectnumber).PixelLocationX \ 16) + objects(objectnumber).XAxisDirection
MapPositionY = (objects(objectnumber).PixelLocationY \ 16) + objects(objectnumber).YAxisDirection

IF MapPositionX < 0 OR MapPositionX > 89 OR MapPositionY < 0 OR MapPositionY > 89 THEN EXIT SUB
CurrentTEstLayer = objects(objectnumber).CurrentLayer

SELECT CASE CurrentTEstLayer
CASE 0
TestMap = MapLevel1(MapPositionX, MapPositionY, 1)
CASE 1
TestMap = MapLevel2(MapPositionX, MapPositionY, 1)
CASE 2
TestMap = MapLevel3(MapPositionX, MapPositionY, 1)
END SELECT
IF ((TestMap <> objectnumber) AND (TestMap <> -1)) THEN SendMessage TestMap, MessageNum
END SUB

SUB BloadX (file$, SGment, Offset, NumBytes!, FilePointer!)

file$ = file$ + CHR$(0) 'must have a NULL for int to terminate.
regs.ax = &H3D00
regs.ds = VARSEG(file$) 'segment of name
regs.dx = SADD(file$)  'offset of name
CALL INTERRUPTX(&H21, regs, regs)
regs.bx = regs.ax 'filehandle

regs.ax = &H4200
regs.cx = VAL("&H" + HEX$(INT(FilePointer! / 65536)))
regs.dx = VAL("&H" + HEX$(FilePointer! MOD 65536))
CALL INTERRUPTX(&H21, regs, regs)

regs.ax = &H3F00
regs.cx = VAL("&H" + HEX$(NumBytes!))
regs.ds = VAL("&H" + HEX$(SGment))
regs.dx = VAL("&H" + HEX$(Offset))
CALL INTERRUPTX(&H21, regs, regs)

regs.ax = &H3E00
CALL INTERRUPTX(&H21, regs, regs)

END SUB

SUB BsaveX (file$, SGment, Offset, NumBytes!, FilePointer!)

OPEN file$ FOR BINARY AS #1
CLOSE #1

file$ = file$ + CHR$(0)
regs.ax = &H3D01
regs.ds = VARSEG(file$)  'segment of filename
regs.dx = SADD(file$) 'offset of filename
CALL INTERRUPTX(&H21, regs, regs)
regs.bx = regs.ax 'filehandle

regs.ax = &H4200
regs.cx = VAL("&H" + HEX$(INT(FilePointer! / 65536)))
regs.dx = VAL("&H" + HEX$(FilePointer! MOD 65536))
CALL INTERRUPTX(&H21, regs, regs)

'saves the screen into the file
regs.ax = &H4000
regs.cx = VAL("&H" + HEX$(NumBytes!))
regs.ds = VAL("&H" + HEX$(SGment))
regs.dx = VAL("&H" + HEX$(Offset))
CALL INTERRUPTX(&H21, regs, regs)

'close the file
regs.ax = &H3E00
CALL INTERRUPTX(&H21, regs, regs)

END SUB

SUB CalibrateJoystick
PRINT "Attempting Joystick..."
PRINT
PRINT "***NOTE PLEASE HIT ESC IF YOU WISH TO SKIP CALIBRATION***"
PRINT "Otherwise, hit SPACE to CALIBRATE JOYSTICK"
DO: blargy = INP(&H60): LOOP UNTIL blargy = 1 OR blargy = 57
IF blarg = 1 THEN JoyStickToggle = 0: EXIT SUB
PRINT
PRINT "Center the Joystick and press any button..."
DO
IF INP(&H60) = 1 THEN JoyStickToggle = 0: EXIT SUB
CenterX = STICK(0)
CenterY = STICK(1)
IF STRIG(0) OR STRIG(1) OR STRIG(2) OR STRIG(3) THEN EXIT DO
LOOP
DO: LOOP UNTIL (STRIG(0) = 0) AND (STRIG(1) = 0) AND (STRIG(2) = 0) AND (STRIG(3) = 0)
PRINT "Move the joystick to the up-left position and press any button..."
DO
IF INP(&H60) = 1 THEN JoyStickToggle = 0: EXIT SUB
Devices.JoyStickLeft = STICK(0)
Devices.JoyStickUp = STICK(1)
IF STRIG(0) OR STRIG(1) OR STRIG(2) OR STRIG(3) THEN EXIT DO
LOOP
Devices.JoyStickLeft = (CenterX - Devices.JoyStickLeft) \ 2: Devices.JoyStickUp = (CenterY - Devices.JoyStickUp) \ 2
DO: LOOP UNTIL (STRIG(0) = 0) AND (STRIG(1) = 0) AND (STRIG(2) = 0) AND (STRIG(3) = 0)
PRINT "Move the joystick to the lower-most right and press any button..."
DO
IF INP(&H60) = 1 THEN JoyStickToggle = 0: EXIT SUB
Devices.JoyStickRight = STICK(0)
Devices.JoyStickDown = STICK(1)
IF STRIG(0) OR STRIG(1) OR STRIG(2) OR STRIG(3) THEN EXIT DO
LOOP
Devices.JoyStickRight = CenterX + ((Devices.JoyStickRight - CenterX) \ 2): Devices.JoyStickDown = CenterY + ((Devices.JoyStickDown - CenterY) \ 2)
PRINT "Joystick Calibrated!"
JoyStickToggle = 1
DevicesBuffer(262) = Devices.JoyStickUp
DevicesBuffer(263) = Devices.JoyStickDown
DevicesBuffer(264) = Devices.JoyStickLeft
DevicesBuffer(265) = Devices.JoyStickRight

END SUB

SUB CenterCamera
CenteredCameraX = CameraX - 160
CenteredCameraY = CameraY - 100
IF CenteredCameraX < 0 THEN CenteredCameraX = 0
IF CenteredCameraY < 0 THEN CenteredCameraY = 0
IF CenteredCameraY > 1248 THEN CenteredCameraY = 1248
IF CenteredCameraX > 1120 THEN CenteredCameraX = 1120
END SUB

SUB Display (array(), MapX, MapY, MaxX, MaxY, displayer)
foundnpcs = 0
FOR cleararray = 0 TO 63
flagnpc(cleararray) = 0
NEXT


StartX = -(MapX AND 15)
Starty = -(MapY AND 15)
StartMapX = MapX \ 16
StartMapY = MapY \ 16
LocationX = StartX
EndX = MaxX - SGN(StartX)
endy = MaxY - SGN(Starty)
FOR showx = 0 TO EndX
 LocationY = Starty
 FOR showy = 0 TO endy
  til = array(StartMapX + showx, StartMapY + showy, 0)
  IF TileData(til).AnimationFrames <> 1 THEN til = til + ((FRAMES& \ TileData(til).AnimationDelayFrames) MOD (TileData(til).AnimationFrames))
  IF til <> 0 THEN put13h TileData(til).Segment, TileData(til).Offset, LocationX, LocationY, 0
 LocationY = LocationY + 16
 NEXT
 LocationX = LocationX + 16
 NEXT

'Object Displaying routine
FOR showy = -1 TO endy + 2
FOR showx = -1 TO EndX + 1
SELECT CASE displayer
CASE 0
ObjectTest = MapLevel1(StartMapX + showx, StartMapY + showy, 1)
CASE 1
ObjectTest = MapLevel2(StartMapX + showx, StartMapY + showy, 1)
CASE 2
ObjectTest = MapLevel3(StartMapX + showx, StartMapY + showy, 1)
END SELECT
IF ObjectTest > -1 THEN
IF objects(ObjectTest).ObjectType > -1 THEN
IF objects(ObjectTest).CurrentLayer = displayer THEN
junkvar = DirectionData(objects(ObjectTest).XAxisDirection, objects(ObjectTest).YAxisDirection) + (objects(ObjectTest).Stepping * 258)
SELECT CASE objects(ObjectTest).CharSetTile
CASE -1
put13h TileData(objects(ObjectTest).TileNumber).Segment, TileData(objects(ObjectTest).TileNumber).Offset, objects(ObjectTest).PixelLocationX - MapX, objects(ObjectTest).PixelLocationY - MapY, 0
CASE ELSE
put13h VARSEG(CharSet(junkvar, objects(ObjectTest).CharSetTile)), VARPTR(CharSet(junkvar, objects(ObjectTest).CharSetTile)), objects(ObjectTest).PixelLocationX - MapX, objects(ObjectTest).PixelLocationY - MapY - 16, 0
'put13h VARSEG(CharSet(junkvar, 1)), VARPTR(CharSet(junkvar, 1)), Objects(ObjectTest).PixelLocationX - MapX, Objects(ObjectTest).PixelLocationY - MapY - 16, 0
END SELECT
END IF
END IF
END IF
NEXT showx, showy
END SUB

SUB ExecuteScript (objectnumber)
IF scripts(objectnumber).bytestowait > 0 THEN
scripts(objectnumber).bytestowait = scripts(objectnumber).bytestowait - 1
EXIT SUB
END IF
SELECT CASE objects(objectnumber).ismoving
CASE 0

number = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
SELECT CASE number

CASE 0
scripts(objectnumber).scriptisrunning = 0
CASE 1

objects(objectnumber).ObjectType = -1

SELECT CASE objects(objectnumber).CurrentLayer
CASE 0
MapLevel1(objects(objectnumber).PixelLocationX \ 16, objects(objectnumber).PixelLocationY \ 16, 1) = -1
CASE 1
MapLevel2(objects(objectnumber).PixelLocationX \ 16, objects(objectnumber).PixelLocationY \ 16, 1) = -1
CASE 2
MapLevel3(objects(objectnumber).PixelLocationX \ 16, objects(objectnumber).PixelLocationY \ 16, 1) = -1
END SELECT

CASE 2
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
objects(objectnumber).MoveToX = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
objects(objectnumber).MoveToY = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
objects(objectnumber).ismoving = 1
CASE 3
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
scripts(objectnumber).bytestowait = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
CASE 4
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
LookNum = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
objects(objectnumber).XAxisDirection = SGN(objects(LookNum).PixelLocationX - objects(objectnumber).PixelLocationX)
objects(objectnumber).YAxisDirection = SGN(objects(LookNum).PixelLocationY - objects(objectnumber).PixelLocationY)
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
CASE 5
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
MsgNumb1 = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
MsgNumb2 = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
MessageBoxEnabled = 1
MessageBoxPositionY = 0
OPEN "spk\Mes" + LTRIM$(RTRIM$(STR$((MsgNumb1 * 256) + MsgNumb2))) + ".spk" FOR INPUT AS #3
INPUT #3, MessageBoxLines
SELECT CASE MessageBoxLines
CASE IS < 8
FOR wipetext = 0 TO 7: TextMessage(wipetext) = "": NEXT
END SELECT
FOR getmessage = 0 TO MessageBoxLines
INPUT #3, TextMessage(getmessage)
NEXT
CLOSE #3
CASE 6
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
TileFlag = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
TileNum = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
TileX = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
TileY = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
MapLevel1(TileX, TileY, 0) = TileNum + (TileFlag * 252)
CASE 7
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
ElevateNumber = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
NewNumber = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1

SELECT CASE objects(ElevateNumber).CurrentLayer
CASE 0
MapLevel1(objects(ElevateNumber).PixelLocationX \ 16, objects(ElevateNumber).PixelLocationY \ 16, 1) = -1
CASE 1
MapLevel2(objects(ElevateNumber).PixelLocationX \ 16, objects(ElevateNumber).PixelLocationY \ 16, 1) = -1
CASE 2
MapLevel3(objects(ElevateNumber).PixelLocationX \ 16, objects(ElevateNumber).PixelLocationY \ 16, 1) = -1
END SELECT

objects(ElevateNumber).CurrentLayer = NewNumber

SELECT CASE objects(ElevateNumber).CurrentLayer
CASE 0
MapLevel1(objects(ElevateNumber).PixelLocationX \ 16, objects(ElevateNumber).PixelLocationY \ 16, 1) = ElevateNumber
CASE 1
MapLevel2(objects(ElevateNumber).PixelLocationX \ 16, objects(ElevateNumber).PixelLocationY \ 16, 1) = ElevateNumber
CASE 2
MapLevel3(objects(ElevateNumber).PixelLocationX \ 16, objects(ElevateNumber).PixelLocationY \ 16, 1) = ElevateNumber
END SELECT


CASE 255
scripts(objectnumber).currentbyte = scripts(objectnumber).backtobyte
scripts(objectnumber).backtobyte = 1
END SELECT


CASE 1
keyx = SGN((objects(objectnumber).MoveToX * 16) - objects(objectnumber).PixelLocationX)
keyy = SGN((objects(objectnumber).MoveToY * 16) - objects(objectnumber).PixelLocationY)
MoveObject objectnumber, keyx, 0
MoveObject objectnumber, 0, keyy
objects(objectnumber).XAxisDirection = keyx
objects(objectnumber).YAxisDirection = keyy

IF objects(objectnumber).MoveToY * 16 = objects(objectnumber).PixelLocationY THEN
IF objects(objectnumber).MoveToX * 16 = objects(objectnumber).PixelLocationX THEN
objects(objectnumber).ismoving = 0
END IF
END IF

END SELECT

END SUB

SUB FontPrint (textstring$, X, Y)
FOR i = 1 TO LEN(textstring$)
 til = 34 * ASC(MID$(textstring$, i, 1))
 put13h VARSEG(font(til)), VARPTR(font(til)), X + (i * 8), Y, 0
NEXT
END SUB

SUB Intro
END SUB

SUB LoadMap
BloadX "map\MAP.DAT", VARSEG(MapLevel1(0, 0, 0)), VARPTR(MapLevel1(0, 0, 0)), 16200, 0
BloadX "map\MAP.DAT", VARSEG(MapLevel2(0, 0, 0)), VARPTR(MapLevel2(0, 0, 0)), 16200, 16200
BloadX "map\MAP.DAT", VARSEG(MapLevel3(0, 0, 0)), VARPTR(MapLevel3(0, 0, 0)), 16200, 32400
END SUB

SUB LoadPal (filename$)
FileNum = FREEFILE
OPEN "pal\" + filename$ FOR BINARY AS #FileNum
OUT &H3C8, 0
FOR i = 0 TO 255
a = ASC(INPUT$(1, FileNum))
OUT &H3C9, a
B = ASC(INPUT$(1, FileNum))
OUT &H3C9, B
C = ASC(INPUT$(1, FileNum))
OUT &H3C9, C
transpal(i) = (a + B + C) \ 16
NEXT
CLOSE #FileNum
END SUB

SUB LoadTiles
DEF SEG = VARSEG(CharSet(0, 0))
BLOAD "put\char.put", VARPTR(CharSet(0, 0))
DEF SEG = VARSEG(tiles(0))
BLOAD "put\tiles.put", VARPTR(tiles(0))
DEF SEG = VARSEG(bottombar(0))
BLOAD "put\bottom.put", VARPTR(bottombar(0))
DEF SEG = VARSEG(font(0))
BLOAD "put\font.put", VARPTR(font(0))
DEF SEG
END SUB

SUB MessageBox

IF DevicesBuffer(Devices.CloseMessage) THEN MessageBoxEnabled = 0: EXIT SUB
IF joysticktoggled = 1 THEN
IF DevicesBuffer(Devices.JoyStickButton2) = 0 THEN MessageBoxEnabled = 0: EXIT SUB
END IF
IF DevicesBuffer(Devices.Scrollup) AND MessageBoxPositionY <> 0 THEN MessageBoxPositionY = MessageBoxPositionY - 1
IF DevicesBuffer(Devices.ScrollDown) AND MessageBoxLines > 7 AND MessageBoxPositionY <> MessageBoxLines - 7 THEN MessageBoxPositionY = MessageBoxPositionY + 1
'TransBox 0, 128, 319, 191, 0
FOR WriteText = 0 TO 7
FontPrint TextMessage(WriteText + MessageBoxPositionY), 0, 128 + (WriteText * 8)
NEXT WriteText
END SUB

SUB MoveObject (objectnumber, pixelmovesX, pixelmovesY)
checkidle = (ABS(pixelmovesX) + ABS(pixelmovesY))
IF checkidle > 0 THEN objects(objectnumber).Steps = objects(objectnumber).Steps + checkidle ELSE EXIT SUB
objects(objectnumber).Stepping = (objects(objectnumber).Steps \ 16) AND 3
IF objects(objectnumber).Stepping = 2 THEN objects(objectnumber).Stepping = 0
IF objects(objectnumber).Stepping = 3 THEN objects(objectnumber).Stepping = 2
objects(objectnumber).XAxisDirection = SGN(pixelmovesX)
objects(objectnumber).YAxisDirection = SGN(pixelmovesY)
MapLayer = objects(objectnumber).CurrentLayer
OX = (objects(objectnumber).PixelLocationX) \ 16
OY = (objects(objectnumber).PixelLocationY) \ 16
OXO = objects(objectnumber).PixelLocationX AND 15
OYO = objects(objectnumber).PixelLocationY AND 15
objects(objectnumber).PixelLocationX = objects(objectnumber).PixelLocationX + pixelmovesX
IF objects(objectnumber).PixelLocationX < 0 THEN
 objects(objectnumber).PixelLocationX = objects(objectnumber).PixelLocationX - pixelmovesX
 EXIT SUB
END IF
objects(objectnumber).PixelLocationY = objects(objectnumber).PixelLocationY + pixelmovesY
IF objects(objectnumber).PixelLocationY < 0 THEN
 objects(objectnumber).PixelLocationY = objects(objectnumber).PixelLocationY - pixelmovesY
 EXIT SUB
END IF
X = (objects(objectnumber).PixelLocationX) \ 16
Y = (objects(objectnumber).PixelLocationY) \ 16
XO = objects(objectnumber).PixelLocationX AND 15
YO = objects(objectnumber).PixelLocationY AND 15
IF (X < 0) OR (Y < 0) OR (X > 89) OR (Y > 89) THEN
 a% = 0
ELSE
 SELECT CASE MapLayer
  CASE 0: a% = MoveObjectHelper%(objectnumber, OX, OY, OXO, OYO, X, Y, XO, YO, MapLevel1())
  CASE 1: a% = MoveObjectHelper%(objectnumber, OX, OY, OXO, OYO, X, Y, XO, YO, MapLevel2())
  CASE 2: a% = MoveObjectHelper%(objectnumber, OX, OY, OXO, OYO, X, Y, XO, YO, MapLevel3())
 END SELECT
END IF
IF a% = 0 THEN
 objects(objectnumber).PixelLocationX = objects(objectnumber).PixelLocationX - pixelmovesX
 objects(objectnumber).PixelLocationY = objects(objectnumber).PixelLocationY - pixelmovesY
END IF
END SUB

'O = object number
'OX,OY = old map x,y
'OXO,OYO = old pixel x,y offset into tile (ie, 0 to 15)
'X,Y = new map x,y
'XO,YO = new pixel x,y offset into tile
'ThisMapLevel() = array for this map level
FUNCTION MoveObjectHelper% (O, OX, OY, OXO, OYO, X, Y, XO, YO, ThisMapLevel() AS INTEGER)
DetectedObject = 0
PX = objects(O).PixelLocationX
PY = objects(O).PixelLocationY
FOR i = -1 TO 1
 FOR J = -1 TO 1
  K = X + i
  L = Y + J
  IF (K >= 0) AND (L >= 0) AND (K <= 89) AND (L <= 89) THEN
   IF (ThisMapLevel(K, L, 1) + 1) AND (ThisMapLevel(K, L, 1) <> O) THEN
    IF ABS(PX - objects(ThisMapLevel(K, L, 1)).PixelLocationX) <= 15 THEN
     IF ABS(PY - objects(ThisMapLevel(K, L, 1)).PixelLocationY) <= 15 THEN
      EXIT FUNCTION
     END IF
    END IF
   END IF
  END IF
 NEXT J
NEXT i
IF (ThisMapLevel(X, Y, 0) > 251) AND (ThisMapLevel(X, Y, 0) < 504) THEN EXIT FUNCTION
IF (ThisMapLevel(X, Y, 1) + 1) AND (ThisMapLevel(X, Y, 1) <> O) THEN
 IF ABS(PX - objects(ThisMapLevel(X, Y, 1)).PixelLocationX) <= 15 THEN
  IF ABS(PY - objects(ThisMapLevel(X, Y, 1)).PixelLocationY) <= 15 THEN
   EXIT FUNCTION
  END IF
 END IF
END IF
IF XO THEN
 IF (ThisMapLevel(X + 1, Y, 0) > 251) AND (ThisMapLevel(X + 1, Y, 0) < 504) THEN EXIT FUNCTION
 IF (ThisMapLevel(X + 1, Y, 1) + 1) AND (ThisMapLevel(X + 1, Y, 1) <> O) THEN
  IF ABS(PX - objects(ThisMapLevel(X + 1, Y, 1)).PixelLocationX) <= 15 THEN
   IF ABS(PY - objects(ThisMapLevel(X + 1, Y, 1)).PixelLocationY) <= 15 THEN
    EXIT FUNCTION
   END IF
  END IF
 END IF
 IF YO THEN
  IF (ThisMapLevel(X + 1, Y + 1, 0) > 251) AND (ThisMapLevel(X + 1, Y + 1, 0) < 504) THEN EXIT FUNCTION
  IF (ThisMapLevel(X + 1, Y + 1, 1) + 1) AND (ThisMapLevel(X + 1, Y + 1, 1) <> O) THEN
   IF ABS(PX - objects(ThisMapLevel(X + 1, Y + 1, 1)).PixelLocationX) <= 15 THEN
    IF ABS(PY - objects(ThisMapLevel(X + 1, Y + 1, 1)).PixelLocationY) <= 15 THEN
     EXIT FUNCTION
    END IF
   END IF
  END IF
 END IF
END IF
IF YO THEN
 IF (ThisMapLevel(X, Y + 1, 0) > 251) AND (ThisMapLevel(X, Y + 1, 0) < 504) THEN EXIT FUNCTION
 IF (ThisMapLevel(X, Y + 1, 1) + 1) AND (ThisMapLevel(X, Y + 1, 1) <> O) THEN
  IF ABS(PX - objects(ThisMapLevel(X, Y + 1, 1)).PixelLocationX) <= 15 THEN
   IF ABS(PY - objects(ThisMapLevel(X, Y + 1, 1)).PixelLocationY) <= 15 THEN
    EXIT FUNCTION
   END IF
  END IF
 END IF
END IF
ThisMapLevel(OX, OY, 1) = -1
ThisMapLevel(X, Y, 1) = O
MoveObjectHelper% = -1
END FUNCTION

SUB ScreenX (modenumber)
regs.ax = modenumber
INTERRUPTX &H10, regs, regs
END SUB

SUB ScrollMessage
InfoLine.Positionx = InfoLine.Positionx - ((FRAMES& AND 1) = 1)
StartPrint = 0
StartX = -(InfoLine.Positionx AND 7)
EndPrint = 40 - SGN(StartX)
StartLetter = InfoLine.Positionx \ 8 + 1
IF StartLetter > (InfoLine.EndX) THEN InfoLine.Positionx = 0
FOR ScrollingLetters = StartPrint TO EndPrint
 til = 34 * ASC(MID$(InfoLine.Text, StartLetter + ScrollingLetters, 1))
 put13h VARSEG(font(til)), VARPTR(font(til)), StartX, 192, 0
StartX = StartX + 8
NEXT
END SUB

SUB SendMessage (objectnumber, MessageData)
IF scripts(objectnumber).scriptisrunning = 1 THEN
scripts(objectnumber).bytestowait = 0
objects(objectnumber).ismoving = 0
scripts(objectnumber).backtobyte = scripts(objectnumber).currentbyte
scripts(objectnumber).currentbyte = 128 + (MessageData * 64)
END IF
END SUB

SUB TransBox (TopLeftX, TopLeftY, BottomRightX, BottomRightY, TransType)
SELECT CASE TransType
CASE 0
DEF SEG = VARSEG(buffer(0))
IF TopLeftX < -15 THEN EXIT SUB
IF TopLeftX < 0 THEN TopLeftX = 0
IF TopLeftY < 0 THEN TopLeftY = 0
IF BottomRightX > 319 THEN BottomRightX = 319
IF BottomRightY > 191 THEN BottomRightY = 191
StartPosition& = TopLeftY * 320& + TopLeftX
FOR PlotY = 0 TO (BottomRightY - TopLeftY)
FOR PlotX = 0 TO (BottomRightX - TopLeftX)
junk = StartPosition& + PlotX
POKE junk, TransColor + transpal(PEEK(junk))
NEXT PlotX
StartPosition& = StartPosition& + 320
NEXT PlotY
CASE 1
DEF SEG = VARSEG(buffer(0))
IF TopLeftX < -15 THEN EXIT SUB
IF TopLeftX < 0 THEN TopLeftX = 0
IF TopLeftY < 0 THEN TopLeftY = 0
IF BottomRightX > 319 THEN BottomRightX = 319
IF BottomRightY > 191 THEN BottomRightY = 191
StartPosition& = TopLeftY * 320& + TopLeftX
FOR PlotY = 1 TO (BottomRightY - TopLeftY) - 1
FOR PlotX = 1 TO (BottomRightX - TopLeftX) - 1
POKE StartPosition& + PlotX, TransColor + (transpal(PEEK(StartPosition& + PlotX + 1)) + transpal(PEEK(StartPosition& + PlotX - 1)) + transpal(PEEK(StartPosition& + PlotX + 320)) + transpal(PEEK(StartPosition& + PlotX - 320))) \ 4
NEXT PlotX
StartPosition& = StartPosition& + 320
NEXT PlotY
END SELECT
END SUB

SUB UpdateObjects (layer)

FOR CheckObject = 0 TO 63

 IF objects(CheckObject).ObjectType <> -1 THEN
  IF objects(CheckObject).CurrentLayer = layer THEN
   SELECT CASE scripts(CheckObject).scriptisrunning
   CASE 0
   SELECT CASE objects(CheckObject).ObjectType
    CASE 1
     keyx = (DevicesBuffer(Devices.RightArrow) - DevicesBuffer(Devices.LeftArrow)) * (1 + DevicesBuffer(Devices.Running))
     keyy = (DevicesBuffer(Devices.DownArrow) - DevicesBuffer(Devices.UpArrow)) * (1 + DevicesBuffer(Devices.Running))
     MoveObject CheckObject, keyx, 0
     MoveObject CheckObject, 0, keyy
     IF DevicesBuffer(57) THEN ActivateRadius CheckObject, 0
    CASE 2
     IF JoyStickToggle = 1 THEN
     keyx = ((DevicesBuffer(Devices.JoyStickLeft) >= DevicesBuffer(Devices.JoyX)) - (DevicesBuffer(Devices.JoyStickRight) <= DevicesBuffer(Devices.JoyX))) * (2 - DevicesBuffer(Devices.JoyStickButton4))
     keyy = ((DevicesBuffer(Devices.JoyStickDown) >= DevicesBuffer(Devices.JoyY)) - (DevicesBuffer(Devices.JoyStickUp) <= DevicesBuffer(Devices.JoyY))) * (2 - DevicesBuffer(Devices.JoyStickButton4))
     ELSE
     keyx = 0
     keyy = 0
     END IF
     MoveObject CheckObject, keyx, 0
     MoveObject CheckObject, 0, keyy
     IF DevicesBuffer(Devices.JoyStickButton1) = 0 THEN ActivateRadius CheckObject, 0
   END SELECT
  
   CASE 1
  
   ExecuteScript CheckObject
  
   END SELECT
  
  
   END IF
 END IF
NEXT
END SUB

